#include "database.hpp"


using namespace std;
using namespace cv;


void readLabels(Mat &train_l, Mat &test_l) {
    
    ifstream labels ("labels.txt");
    int elm;
    if (labels.is_open()) 
        
    
        for (int i=0; i<6000; i++) {
            labels >> elm;
            if (i <num_train_sample)
                train_l.at<float>(0,i) = elm;
        }
        for (int i=0; i<6000; i++) {
            labels >> elm;
            if (i < num_test_sample)
                test_l.at<float>(0,i) = elm;
        }
    
    labels.close();
}

void extractFeatures(Mat &train, Mat &test, Mat &train_l, Mat &test_l) {
    ostringstream nome;
    int temp;
    int i,k, linha, coluna;
    
    for (i=1; i<=num_train_sample; i++){
        nome.str("");
        nome << "train/" << i << ".png";
        Mat im = imread(nome.str(),0);
        
        //copia cada imagem como um vetor linha para a matriz de saída
        k=0;
       
        
        for (linha=0; linha<im.rows; linha++) 
            for (coluna=0; coluna < im.cols; coluna ++) {
                temp = im.at<uchar>(linha, coluna);
                train.at<float>(i-1,k) = (float)temp;
                k++;
            }
    }
    
    
    
    
    for (i=6001; i<=6000+num_test_sample; i++){
        nome.str("");
        nome << "test/" << i << ".png";
        Mat im = imread(nome.str(),0);
        
        //copia cada imagem como um vetor linha para a matriz de saída
        k=0;
        for (linha=0; linha<im.rows; linha++) 
            for (coluna=0; coluna < im.cols; coluna ++) {
                temp = im.at<uchar>(linha, coluna);
                test.at<float>(i-6001,k) = (float)temp;
                k++;
            }
    }
    
    
    readLabels(train_l, test_l);
     

}


void extractFeaturesHOG(Mat &train, Mat &test, Mat &train_l, Mat &test_l) {
    ostringstream nome;
    int i,k, desc;
    
    HOGDescriptor hog( Size(16,16), Size(8,8), Size(4,4), Size(4,4), 8); 
    vector<float> descriptorsValues;
    
    for (i=1; i<=num_train_sample; i++){
        nome.str("");
        nome << "train/" << i << ".png";
        Mat im = imread(nome.str(),0);
        
        //gera HOG
        k=0;
        hog.compute( im, descriptorsValues);
       
        for (desc=0; desc<descriptorsValues.size(); desc++) 
            train.at<float>(i-1,k++) = descriptorsValues.at(desc);
    }
    
    
    
    
    for (i=6001; i<=6000+num_test_sample; i++){
        nome.str("");
        nome << "test/" << i << ".png";
        Mat im = imread(nome.str(),0);
        
       //gera HOG
        k=0;
        hog.compute( im, descriptorsValues);
        
        for (desc=0; desc<descriptorsValues.size(); desc++) 
            test.at<float>(i-6001,k++) = descriptorsValues.at(desc);
    }
    
    readLabels(train_l, test_l);

}
